<?php

  class mw_env_config extends mw_env
  {

    function load_config($config_file)
    { if($config_file && file_exists($config_file))
      { $this->env->config_file = $config_file;
        require $config_file;
        $this->env->PATHES = $PATHES;
        $this->env->bdd = $bdd;
        $this->env->CONFIG = isset($CONFIG) ? $CONFIG : array();
        $this->env->PATHES["app"] = $this->env->PATHES["app"].($this->env->PATHES["app"] && substr($this->env->PATHES["app"], -1) != "/" ? "/" : "");
        $this->env->PATHES["current_app"] = $this->env->PATHES["current_app"].($this->env->PATHES["current_app"] && substr($this->env->PATHES["current_app"], -1) != "/" ? "/" : "");
        $this->env->PATHES["core_app"] = $this->env->PATHES["core_app"].($this->env->PATHES["core_app"] && substr($this->env->PATHES["core_app"], -1) != "/" ? "/" : "");
        if($app_config_file = ($this->app_file_exists("config.xml") ? $this->app_file("config.xml") : ""))
        { $app_config = simplexml_load_file($app_config_file);
          $this->env->PATHES["libs"] = utf8_decode($app_config->pathes->libs);
          foreach($this->env->PATHES as $path_name => $path_value)
          { if($path_value && substr($path_value, -1) != "/") $this->env->PATHES[$path_name] .= "/";
          }
          $this->env->PARAMS = array();
          foreach($app_config->params[0] as $code_param => $get_param)
          { $this->env->PARAMS[$code_param] = utf8_decode($get_param);
          }
          $this->init_additional_get_params();
          $this->env->bdd["table_prefix"] = array();
          $this->add_table_prefix(array(utf8_decode($app_config->bdd->table_prefix_code) => $bdd["table_prefix"]));
        }
        else $this->erreur("impossible de trouver le fichier de configuration pour l'application", true);
      }
      else $this->erreur("impossible de trouver le fichier de configuration pour l'installation", true);
    }

    function path($name) { return $this->env->PATHES[$name]; }
    function param($name) { return $this->env->PARAMS[$name]; }
    function config($name) { return $this->env->CONFIG[$name]; }
    function bdd($name) { return $this->env->bdd[$name]; }

    function set_config($config)
    { if(is_array($config))
      { foreach($config as $key => $value) $this->env->CONFIG[$key] = $value;
        return true;
      }
      return false;
    }

    function add_table_prefix($table_prefix)
    { if(is_array($table_prefix))
      { foreach($table_prefix as $prefix_code => $prefix) $this->env->bdd["table_prefix"][$prefix_code] = $prefix;
        return true;
      }
      return false;
    }

  }

?>