<?php

  class mw_env
  {
    public $modules;
    public $config_file;
    public $etat;
    public $out;
    public $PATHES;
    public $PARAMS;
    public $CONFIG;
    public $additional_get_params;
    public $bdd;
    public $data;
    public $layout;
    public $parent;
    public $env;

    function __construct($app_path, $parent = null, $root_env = null)
    { $this->modules = array();
      $this->config_file = false;
      $this->etat = array();
      $this->out = array();
      $this->PATHES = array();
      $this->PARAMS = array();
      $this->CONFIG = array();
      $this->additional_get_params = array();
      $this->bdd = array();
      $this->data = false;
      $this->layout = false;
      $this->parent = $parent;
      if(isset($root_env)) $this->env = $root_env;
      else $this->env = $this;
    }

    function app_file_exists($file)
    { return
      ( file_exists($this->env->PATHES["app"].$this->env->PATHES["current_app"].$file) ||
        file_exists($this->env->PATHES["app"].$this->env->PATHES["core_app"].$file)
      );
    }

    function app_file($file)
    { return
      ( file_exists($this->env->PATHES["app"].$this->env->PATHES["current_app"].$file) ?
          $this->env->PATHES["app"].$this->env->PATHES["current_app"].$file
        : ( file_exists($this->env->PATHES["app"].$this->env->PATHES["core_app"].$file) ?
               $this->env->PATHES["app"].$this->env->PATHES["core_app"].$file
            : $file
          )
      );
    }

    function load_app($app_path, $current_app, $core_app)
    { $this->load_modules($app_path, $current_app."env/", $this->env, true);
      if($current_app != $core_app)
      { $this->load_modules($app_path, $core_app."env/", $this->env, true);
      }
    }

    function load($app_path, $file_path, $root_env)
    { if($file_path && file_exists($file_path))
      { $v_path = explode("/", $file_path);
        $file = $v_path[count($v_path) - 1];
        if(strcasecmp(substr($file, -4), ".php") == 0)
        { $class_name = substr($file, 0, -4);
          if(!class_exists($class_name))
          { require_once $file_path;
            if(class_exists($class_name) && !$this->modules[$class_name])
            { $this->modules[$class_name] = new $class_name($app_path, $this, $root_env);
            }
          }
        }
      }
    }

    function load_modules($app_path, $modules_path, $root_env, $recursif = false)
    { if(file_exists($app_path.$modules_path) && $dh = opendir($app_path.$modules_path))
      { while(($file = readdir($dh)) !== false)
        { if(is_dir($app_path.$modules_path.$file))
          { if($recursif && substr($file, 0, 1) != ".") $this->load_modules($app_path, $modules_path.$file."/", $root_env, $recursif);
          }
          elseif(strcasecmp(substr($file, -4), ".php") == 0) $this->load($app_path, $app_path.$modules_path.$file, $root_env);
        }
        closedir($dh);
      }
    }

    function __call($method_name, $arguments)
    { return $this->env_call($this->env, $method_name, $arguments);
    }

    function env_call($env_impl, $method_name, $arguments)
    { $r = false;
      $args = "";
      foreach($arguments as $i => $arg) $args .= ($args ? ", " : "")."\$arguments[".$i."]";
      foreach($env_impl->modules as $module_name => $module)
      { if(method_exists($module, $method_name))
        { eval("\$r = \$module->".$method_name."(".$args.");");
          break;
        }
        else
        { $r = $this->env_call($module, $method_name, $arguments);
          if($r !== false) break;
        }
      }
      return $r;
    }

  }

?>